using System;
using System.Data;
using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.ComponentModel;
using System.IO;

namespace DataStorageWebService_CS
{
    /// <summary>
    /// 
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [ToolboxItem(false)]
    public class Service1 : System.Web.Services.WebService
    {
        private enum DocTypes
        {
            WordDocument = 0, ExcelWorkbook = 1, PowerPointPresentation = 2, OutlookEmail = 3
        }

        public Service1()
        {
            string documentsFolder = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            string demoFolder = Path.Combine(documentsFolder, "Add-in Express Demo");
            if (!Directory.Exists(demoFolder))
                Directory.CreateDirectory(demoFolder);
            string wordStorage = Path.Combine(demoFolder, "WordDocuments");
            if (!Directory.Exists(wordStorage))
                Directory.CreateDirectory(wordStorage);
            string excelStorage = Path.Combine(demoFolder, "ExcelWorkbooks");
            if (!Directory.Exists(excelStorage))
                Directory.CreateDirectory(excelStorage);
            string pptStorage = Path.Combine(demoFolder, "PowerPointPresentations");
            if (!Directory.Exists(pptStorage))
                Directory.CreateDirectory(pptStorage);
            string outlookStorage = Path.Combine(demoFolder, "OutlookEmails");
            if (!Directory.Exists(outlookStorage))
                Directory.CreateDirectory(outlookStorage);
        }

        [WebMethod]
        public void SaveData(int type, string name, byte[] data)
        {
            string documentsFolder = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            string folder = Path.Combine(documentsFolder, "Add-in Express Demo");
            switch ((DocTypes)type)
            {
                case DocTypes.WordDocument:
                    folder = Path.Combine(folder, "WordDocuments");
                    break;
                case DocTypes.ExcelWorkbook:
                    folder = Path.Combine(folder, "ExcelWorkbooks");
                    break;
                case DocTypes.PowerPointPresentation:
                    folder = Path.Combine(folder, "PowerPointPresentations");
                    break;
                case DocTypes.OutlookEmail:
                    folder = Path.Combine(folder, "OutlookEmails");
                    break;
            }
            string fileName = Path.Combine(folder, name);
            File.WriteAllBytes(fileName, data);
        }

        [WebMethod]
        public byte[] LoadData(int type, string name)
        {
            string documentsFolder = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            string folder = Path.Combine(documentsFolder, "Add-in Express Demo");
            switch ((DocTypes)type)
            {
                case DocTypes.WordDocument:
                    folder = Path.Combine(folder, "WordDocuments");
                    break;
                case DocTypes.ExcelWorkbook:
                    folder = Path.Combine(folder, "ExcelWorkbooks");
                    break;
                case DocTypes.PowerPointPresentation:
                    folder = Path.Combine(folder, "PowerPointPresentations");
                    break;
                case DocTypes.OutlookEmail:
                    folder = Path.Combine(folder, "OutlookEmails");
                    break;
            }
            string fileName = Path.Combine(folder, name);
            if (File.Exists(fileName))
                return File.ReadAllBytes(fileName);
            return null;
        }

        [WebMethod]
        public string[] GetListOfData(int type)
        {
            string documentsFolder = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            string folder = Path.Combine(documentsFolder, "Add-in Express Demo");
            switch ((DocTypes)type)
            {
                case DocTypes.WordDocument:
                    folder = Path.Combine(folder, "WordDocuments");
                    break;
                case DocTypes.ExcelWorkbook:
                    folder = Path.Combine(folder, "ExcelWorkbooks");
                    break;
                case DocTypes.PowerPointPresentation:
                    folder = Path.Combine(folder, "PowerPointPresentations");
                    break;
                case DocTypes.OutlookEmail:
                    folder = Path.Combine(folder, "OutlookEmails");
                    break;
            }
            string[] getFileName = Directory.GetFiles(folder);
            for (int i = 0; i < getFileName.Length; i++)
            {
                getFileName[i] = Path.GetFileName(Directory.GetFiles(folder)[i]);
            }
            return getFileName;
        }
    }
}
